#include <string>
#include <list>
#include <windows.h>
#include <commdlg.h>
#include <shellapi.h>

class CMyFileDialog
{
	const std::string c_title;
	const std::string c_ext;
	const std::string c_filter;
	std::string m_title;
	std::string m_ext;
	char *m_filter;
	std::list<std::string> m_files;
	HWND m_hOwnerWnd;
	DWORD m_ofnFlags;

	BOOL SafeGetOpenFileName(LPOPENFILENAMEA lpofn);
	BOOL SafeGetSaveFileName(LPOPENFILENAMEA lpofn);
	typedef BOOL (CMyFileDialog::*GetOpenSaveFileName)(LPOPENFILENAMEA);
	GetOpenSaveFileName getOpenSaveFileNamePtr;

	bool runDialog(LPOPENFILENAMEA lpofn, std::list<std::string>&);

	int strlen_doublenull(const char*);

public:
	CMyFileDialog();
	~CMyFileDialog();

	// "J" _CAO̕Wݒǂݍ
	void setOpenDlgDefaultSetting(void);

	// "Otĕۑ" _CAO̕Wݒǂݍ
	void setSaveDlgDefaultSetting(void);

	// _CAÕ^Cgݒ肷
	void setTitle(const char*);

	// _CAO̕Wgqݒ肷
	void setDefaultExt(const char*);

	// _CAÕtB^[ݒ肷
	void setFilter(const char*);

	//_CAȌLEBhEݒ肷
	void setOwner(HWND);

	// _CAOWJ
	bool Execute(void);

	// obt@̃t@CpXo
	const char *getFile(int);

	// obt@̃Xgo
	int getIndex(void);
};

